// ============================================================================
// $Id: protocol.hh,v 1.2 1996/04/26 23:33:04 questor Exp $
//
// This is part of Realm Of Magic
//
// Usage: Class that serves as base class for protocols
//
// All rights reserved. See license.doc for complete information.
//
// Copyright (C) 1993-1996 by the Hackerz of the Realm Of Magic
// Realm Of Magic is based on CircleMUD, Copyright (C) 1993.
// CircleMUD is based on DikuMUD, Copyright (C) 1990, 1991.
// Original intermud_client.c (C) 1995, 96 by Chris Austin (Stryker@Tempus)
// Original lpc protocol (C) by Mark Lewis (Nostradamus@Zebedee)
//                           by J.W. Armstrong (Alvin@Sushi)
// ============================================================================

#ifndef __INTERMUD__PROTOCOL_HH__
#define __INTERMUD__PROTOCOL_HH__

#include "imuddefs.hh"

class _protocol {
protected:
  list<dns_record> dns_table;

  virtual string TypeName() = 0;
  virtual string BasedOn() = 0;
  void update_statistics(string &, int, int);

public:
  virtual void Startup() = 0;
  virtual void SendPings() = 0;
  void GetStatistics();
  bool VerifyAccess(sockaddr_in &, string &);
  void ListMuds();
  bool GetMudinfo(string &, string &);
  bool MuteMud(string &, string &);
  virtual void PurgeList();
  virtual bool IncomingMessage(string &, sockaddr_in &) = 0;
};

#endif

  


